PF-build.sh 34 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Donnot istall 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machinename> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 1.0.6-Build_10
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with english only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and english only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selction GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR english only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Splitted the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Ardunio IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env gihub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards github fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modiffied checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers respository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for comming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. #### Start check if OSTYPE is supported
  117. OS_FOUND=$( command -v uname)
  118. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  119. linux*)
  120. TARGET_OS="linux"
  121. ;;
  122. msys*|cygwin*|mingw*)
  123. # or possible 'bash on windows'
  124. TARGET_OS='windows'
  125. ;;
  126. nt|win*)
  127. TARGET_OS='windows'
  128. ;;
  129. *)
  130. TARGET_OS='unknown'
  131. ;;
  132. esac
  133. # Windows
  134. if [ $TARGET_OS == "windows" ]; then
  135. if [ $(uname -m) == "x86_64" ]; then
  136. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  137. Processor="64"
  138. elif [ $(uname -m) == "i386" ]; then
  139. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  140. Processor="32"
  141. else
  142. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  143. echo "Please refer to the notes of build.sh$(tput sgr0)"
  144. exit 1
  145. fi
  146. # Linux
  147. elif [ $TARGET_OS == "linux" ]; then
  148. if [ $(uname -m) == "x86_64" ]; then
  149. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  150. Processor="64"
  151. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  152. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  153. Processor="32"
  154. else
  155. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  156. echo "Please refer to the notes of build.sh$(tput sgr0)"
  157. exit 1
  158. fi
  159. else
  160. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  161. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  162. echo "Read the notes of build.sh$(tput sgr0)"
  163. exit 1
  164. fi
  165. sleep 2
  166. #### End check if OSTYPE is supported
  167. #### Prepare bash environment and check if wget, zip and other needed things are available
  168. # Check wget
  169. if ! type wget > /dev/null; then
  170. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  171. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  172. exit 2
  173. fi
  174. # Check for zip
  175. if ! type zip > /dev/null; then
  176. if [ $TARGET_OS == "windows" ]; then
  177. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  178. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  179. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  180. echo "Run git Bash under Administrator privilege and"
  181. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  182. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  183. exit 3
  184. elif [ $TARGET_OS == "linux" ]; then
  185. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  186. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  187. exit 3
  188. fi
  189. fi
  190. # Check python ... needed during language build
  191. if ! type python > /dev/null; then
  192. if [ $TARGET_OS == "windows" ]; then
  193. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  194. exit 4
  195. elif [ $TARGET_OS == "linux" ]; then
  196. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  197. echo "As Python 2.x will not be maintained from 2020 please,"
  198. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  199. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  200. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  201. exit 4
  202. fi
  203. fi
  204. #### End prepare bash environment
  205. #### Set build environment
  206. ARDUINO_ENV="1.8.5"
  207. BUILD_ENV="1.0.6"
  208. BOARD="rambo"
  209. BOARD_PACKAGE_NAME="PrusaResearchRambo"
  210. BOARD_VERSION="1.0.1"
  211. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  212. BOARD_FILENAME="prusa3drambo"
  213. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3drambo-1.0.1.tar.bz2"
  214. PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env/releases/download/$BUILD_ENV/PF-build-env-$BUILD_ENV.zip"
  215. LIB="PrusaLibrary"
  216. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  217. # List few useful data
  218. echo
  219. echo "Script path :" $SCRIPT_PATH
  220. echo "OS :" $OS
  221. echo "OS type :" $TARGET_OS
  222. echo ""
  223. echo "Ardunio IDE :" $ARDUINO_ENV
  224. echo "Build env :" $BUILD_ENV
  225. echo "Board :" $BOARD
  226. echo "Package name:" $BOARD_PACKAGE_NAME
  227. echo "Specific Lib:" $LIB
  228. echo ""
  229. #### Start prepare building environment
  230. #Check if build exists and creates it if not
  231. if [ ! -d "../PF-build-dl" ]; then
  232. mkdir ../PF-build-dl || exit 5
  233. fi
  234. cd ../PF-build-dl || exit 6
  235. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  236. # Check if PF-build-env-<version> exists and downloads + creates it if not
  237. # The build environment is based on the supported Arduino IDE portable version with some changes
  238. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  239. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  240. mkdir ../PF-build-env-$BUILD_ENV
  241. sleep 5
  242. fi
  243. # Download and extract supported Arduino IDE depending on OS
  244. # Windows
  245. if [ $TARGET_OS == "windows" ]; then
  246. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  247. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  248. sleep 2
  249. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 7
  250. echo "$(tput sgr 0)"
  251. fi
  252. if [ ! -d "../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor" ]; then
  253. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  254. sleep 2
  255. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 7
  256. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor
  257. echo "# arduino-$ARDUINO_ENV-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$TARGET_OS-$Processor
  258. echo "$(tput sgr0)"
  259. fi
  260. fi
  261. # Linux
  262. if [ $TARGET_OS == "linux" ]; then
  263. # 32 or 64 bit version
  264. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  265. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  266. sleep 2
  267. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  268. echo "$(tput sgr 0)"
  269. fi
  270. if [[ ! -d "../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$TARGET_OS-$Processor.txt" ]]; then
  271. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  272. sleep 2
  273. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 8
  274. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor
  275. echo "# arduino-$ARDUINO_ENV-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$TARGET_OS-$Processor.txt
  276. echo "$(tput sgr0)"
  277. fi
  278. fi
  279. # Make Arduino IDE portable
  280. if [ ! -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/ ]; then
  281. mkdir ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/
  282. fi
  283. if [ ! -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/ ]; then
  284. mkdir ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable
  285. fi
  286. if [ ! -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/output/ ]; then
  287. mkdir ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/output
  288. fi
  289. if [ ! -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/ ]; then
  290. mkdir ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages
  291. fi
  292. if [ ! -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  293. mkdir ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/sketchbook
  294. fi
  295. if [ ! -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  296. mkdir ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/sketchbook/libraries
  297. fi
  298. if [ ! -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/staging/ ]; then
  299. mkdir ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/staging
  300. fi
  301. # Change Arduino IDE preferences
  302. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$TARGET_OS-$Processor.txt ]; then
  303. echo "$(tput setaf 6)Setting $TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  304. sleep 2
  305. echo "update.check"
  306. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/lib/preferences.txt
  307. echo "board"
  308. sed -i 's/board = uno/board = $BOARD/g' ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/lib/preferences.txt
  309. echo "editor.linenumbers"
  310. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/lib/preferences.txt
  311. echo "boardsmanager.additional.urls"
  312. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/lib/preferences.txt
  313. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/lib/preferences.txt
  314. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/lib/preferences.txt
  315. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/lib/preferences.txt
  316. echo "# Preferences-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$TARGET_OS-$Processor.txt
  317. echo "$(tput sgr0)"
  318. fi
  319. # Download and extract Prusa Firmware related parts
  320. # Download and extract PrusaResearchRambo board
  321. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  322. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  323. sleep 2
  324. wget $BOARD_FILE_URL || exit 9
  325. fi
  326. if [[ ! -d "../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  327. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  328. sleep 2
  329. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 10
  330. if [ ! -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  331. mkdir ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  332. fi
  333. if [ ! -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  334. mkdir ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  335. fi
  336. if [ ! -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  337. mkdir ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  338. fi
  339. if [ ! -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  340. mkdir ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  341. fi
  342. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  343. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  344. echo "$(tput sgr 0)"
  345. fi
  346. # Download and extract Prusa Firmware specific library files
  347. if [ ! -f "PF-build-env-$BUILD_ENV.zip" ]; then
  348. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  349. sleep 2
  350. wget $PF_BUILD_FILE_URL || exit 11
  351. echo "$(tput sgr 0)"
  352. fi
  353. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$TARGET_OS-$Processor.txt" ]; then
  354. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  355. sleep 2
  356. unzip -o PF-build-env-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor || exit 12
  357. echo "# PF-build-env-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$TARGET_OS-$Processor.txt
  358. echo "$(tput sgr0)"
  359. fi
  360. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  361. if [ -d "../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  362. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  363. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  364. sleep 2
  365. fi
  366. if [ -d "../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  367. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  368. sleep 2
  369. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  370. sleep 2
  371. cp -f ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  372. echo "# PF-build-env-portable-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$TARGET_OS-$Processor.txt
  373. echo "$(tput sgr0)"
  374. fi
  375. if [ -d "../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  376. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  377. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  378. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  379. sleep 2
  380. echo "$(tput sgr0)"
  381. exit 13
  382. fi
  383. #### End prepare building
  384. #### Start
  385. cd $SCRIPT_PATH
  386. # First argument defines which variant of the Prusa Firmware will be compiled
  387. if [ -z "$1" ] ; then
  388. # Select which variant of the Prusa Firmware will be compiled, like
  389. PS3="Select a variant: "
  390. while IFS= read -r -d $'\0' f; do
  391. options[i++]="$f"
  392. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  393. select opt in "${options[@]}" "All" "Quit"; do
  394. case $opt in
  395. *.h)
  396. VARIANT=$(basename "$opt" ".h")
  397. VARIANTS[i++]="$opt"
  398. break
  399. ;;
  400. "All")
  401. VARIANT="All"
  402. VARIANTS=${options[*]}
  403. break
  404. ;;
  405. "Quit")
  406. echo "You chose to stop"
  407. exit
  408. ;;
  409. *)
  410. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  411. ;;
  412. esac
  413. done
  414. else
  415. if [ -f "$SCRIPT_PATH/Firmware/variants/$1" ] ; then
  416. VARIANTS=$1
  417. else
  418. echo "$(tput setaf 1)$1 could not be found in Firmware/variants please choose a valid one$(tput setaf 2)"
  419. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  420. echo "$(tput sgr0)"
  421. exit 21
  422. fi
  423. fi
  424. #Second argument defines if it is an english only version. Known values EN_ONLY / ALL
  425. #Check default language mode
  426. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  427. if [ -z "$2" ] ; then
  428. PS3="Select a language: "
  429. echo
  430. echo "Which lang-build do you want?"
  431. select yn in "Multi languages" "English only"; do
  432. case $yn in
  433. "Multi languages")
  434. LANGUAGES="ALL"
  435. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  436. break
  437. ;;
  438. "English only")
  439. LANGUAGES="EN_ONLY"
  440. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  441. break
  442. ;;
  443. *)
  444. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  445. ;;
  446. esac
  447. done
  448. else
  449. if [[ "$2" == "ALL" || "$2" == "EN_ONLY" ]] ; then
  450. LANGUAGES=$2
  451. else
  452. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  453. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as 2nd argument!"
  454. exit 22
  455. fi
  456. fi
  457. #Check if DEV_STATUS is selected via argument 3
  458. if [ ! -z "$3" ] ; then
  459. if [[ "$3" == "GOLD" || "$3" == "RC" || "$3" == "BETA" || "$3" == "ALPHA" || "$3" == "DEVEL" || "$3" == "DEBUG" ]] ; then
  460. DEV_STATUS_SELECTED=$3
  461. else
  462. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  463. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL' or 'DEBUG'$(tput sgr0) are allowed as 3rd argument!$(tput sgr0)"
  464. exit 23
  465. fi
  466. fi
  467. #Set BUILD_ENV_PATH
  468. cd ../PF-build-env-$BUILD_ENV/$TARGET_OS-$Processor || exit 24
  469. BUILD_ENV_PATH="$( pwd -P )"
  470. cd ../..
  471. #Checkif BUILD_PATH exists and if not creates it
  472. if [ ! -d "Prusa-Firmware-build" ]; then
  473. mkdir Prusa-Firmware-build || exit 25
  474. fi
  475. #Set the BUILD_PATH for Arduino IDE
  476. cd Prusa-Firmware-build || exit 26
  477. BUILD_PATH="$( pwd -P )"
  478. for v in ${VARIANTS[*]}
  479. do
  480. VARIANT=$(basename "$v" ".h")
  481. # Find firmware version in Configuration.h file and use it to generate the hex filename
  482. FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  483. # Find build version in Configuration.h file and use it to generate the hex filename
  484. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  485. # Check if the motherboard is an EINSY and if so only one hex file will generated
  486. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  487. # Check development status
  488. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  489. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  490. if [[ "$DEV_CHECK" == "RC1" || "$DEV_CHECK" == "RC2" ]] ; then
  491. DEV_STATUS="RC"
  492. elif [[ "$DEV_CHECK" == "ALPHA" ]]; then
  493. DEV_STATUS="ALPHA"
  494. elif [[ "$DEV_CHECK" == "BETA" ]]; then
  495. DEV_STATUS="BETA"
  496. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  497. DEV_STATUS="DEVEL"
  498. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  499. DEV_STATUS="DEBUG"
  500. else
  501. DEV_STATUS="UNKNOWN"
  502. echo
  503. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  504. PS3="Select YES only if source code is tested and trusted: "
  505. select yn in "Yes" "No"; do
  506. case $yn in
  507. Yes)
  508. DEV_STATUS="GOLD"
  509. DEV_STATUS_SELECTED="GOLD"
  510. break
  511. ;;
  512. No)
  513. DEV_STATUS="UNKNOWN"
  514. DEV_STATUS_SELECTED="UNKNOWN"
  515. break
  516. ;;
  517. *)
  518. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  519. ;;
  520. esac
  521. done
  522. fi
  523. else
  524. DEV_STATUS=$DEV_STATUS_SELECTED
  525. fi
  526. #Prepare hex files folders
  527. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  528. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 27
  529. fi
  530. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  531. #Check if exactly the same hexfile already exists
  532. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  533. echo ""
  534. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  535. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  536. read -t 10 -p "Press Enter to continue..."
  537. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  538. echo ""
  539. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  540. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  541. read -t 10 -p "Press Enter to continue..."
  542. fi
  543. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  544. echo ""
  545. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  546. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  547. read -t 10 -p "Press Enter to continue..."
  548. fi
  549. #List some useful data
  550. echo "$(tput setaf 2)$(tput setab 7) "
  551. echo "Variant :" $VARIANT
  552. echo "Firmware :" $FW
  553. echo "Build # :" $BUILD
  554. echo "Dev Check :" $DEV_CHECK
  555. echo "DEV Status :" $DEV_STATUS
  556. echo "Motherboard:" $MOTHERBOARD
  557. echo "Languages :" $LANGUAGES
  558. echo "Hex-file Folder:" $OUTPUT_FOLDER
  559. echo "$(tput sgr0)"
  560. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  561. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  562. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 28
  563. else
  564. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  565. read -t 10 -p "Press Enter to continue..."
  566. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 28
  567. fi
  568. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  569. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  570. # set FW_REPOSITORY
  571. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  572. #Prepare english only or multilanguage version to be build
  573. if [ $LANGUAGES == "ALL" ]; then
  574. echo " "
  575. echo "Multi-language firmware will be built"
  576. echo " "
  577. else
  578. echo " "
  579. echo "English only language firmware will be built"
  580. echo " "
  581. fi
  582. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  583. # if [ $TARGET_OS == "windows" ]; then
  584. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  585. # fi
  586. #### End of Prepare building
  587. #### Start building
  588. export ARDUINO=$BUILD_ENV_PATH
  589. #echo $BUILD_ENV_PATH
  590. #export BUILDER=$ARDUINO/arduino-builder
  591. echo
  592. #read -t 5 -p "Press Enter..."
  593. echo
  594. echo "Start to build Prusa Firmware ..."
  595. echo "Using variant $VARIANT$(tput setaf 3)"
  596. sleep 2
  597. #$BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -ide-version=10805 -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  598. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -ide-version=10805 -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  599. echo "$(tput sgr 0)"
  600. if [ $LANGUAGES == "ALL" ]; then
  601. echo "$(tput setaf 2)"
  602. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  603. echo "$(tput sgr 0)"
  604. sleep 2
  605. cd $SCRIPT_PATH/lang
  606. echo "$(tput setaf 3)"
  607. ./config.sh || exit 31
  608. echo "$(tput sgr 0)"
  609. # Check if previous languages and firmware build exist and if so clean them up
  610. if [ -f "lang_en.tmp" ]; then
  611. echo ""
  612. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  613. read -t 10 -p "Press Enter to continue..."
  614. echo "$(tput setaf 3)"
  615. ./lang-clean.sh
  616. echo "$(tput sgr 0)"
  617. fi
  618. if [ -f "progmem.out" ]; then
  619. echo ""
  620. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  621. read -t 10 -p "Press Enter to continue..."
  622. echo "$(tput setaf 3)"
  623. ./fw-clean.sh
  624. echo "$(tput sgr 0)"
  625. fi
  626. # build languages
  627. echo "$(tput setaf 3)"
  628. ./lang-build.sh || exit 32
  629. # Combine compiled firmware with languages
  630. ./fw-build.sh || exit 33
  631. echo "$(tput sgr 0)"
  632. # Check if the motherboard is an EINSY and if so only one hex file will generated
  633. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  634. # If the motherboard is an EINSY just copy one hexfile
  635. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  636. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  637. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  638. else
  639. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  640. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  641. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  642. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  643. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  644. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  645. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  646. if [ $TARGET_OS == "windows" ]; then
  647. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  648. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  649. elif [ $TARGET_OS == "linux" ]; then
  650. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  651. fi
  652. fi
  653. # Cleanup after build
  654. echo "$(tput setaf 3)"
  655. ./fw-clean.sh || exit 34
  656. ./lang-clean.sh || exit 35
  657. echo "$(tput sgr 0)"
  658. else
  659. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  660. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 34
  661. fi
  662. # Cleanup Firmware
  663. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 36
  664. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  665. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  666. echo $MULTI_LANGUAGE_CHECK
  667. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  668. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  669. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  670. sleep 5
  671. done
  672. # Switch to hex path and list build files
  673. cd $SCRIPT_PATH
  674. cd ..
  675. echo "$(tput setaf 2) "
  676. echo " "
  677. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  678. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  679. #### End building